"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const {
  width
} = _reactNative.Dimensions.get('window');

const inputValue = [1, 1.5, 2];

const HeaderImageScroll = /*#__PURE__*/_react.default.forwardRef((_ref, ref) => {
  let {
    children,
    image,
    containerStyle,
    imageStyle = {
      height: width,
      width,
      resizeMode: 'cover'
    },
    renderImageItem = () => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null),
    renderHeader = () => null,
    ...props
  } = _ref;
  const animatedValue = new _reactNative.Animated.Value(1);
  const headerRef = (0, _react.useRef)();
  console.log(animatedValue);
  const imageScale = animatedValue.interpolate({
    inputRange: [-1, 1, 2],
    outputRange: [2, 1, 2],
    extrapolate: 'clamp'
  });
  const borderRadiusValue = animatedValue.interpolate({
    inputRange: inputValue,
    outputRange: [30, 15, 0],
    extrapolate: "clamp"
  });
  const gravityDown = animatedValue.interpolate({
    inputRange: [1, 1.1],
    outputRange: [5, 100],
    extrapolate: "clamp"
  });

  const _onScrollHandler = e => {
    const scrollYPositionByWidth = e.nativeEvent.contentOffset.y / width + 1;

    if (scrollYPositionByWidth < 3) {
      animatedValue.setValue(scrollYPositionByWidth);
    }
  };

  const animatedHeaderStyleMemo = (0, _react.useMemo)(() => animatedHeaderStyle(borderRadiusValue, containerStyle), [borderRadiusValue, containerStyle]);
  const allowStickyHeader = (0, _react.useMemo)(() => renderHeader() ? [1] : undefined, [renderHeader]);
  const gravityDownHeaderStyleMemo = (0, _react.useMemo)(() => gravityDownHeaderStyle(gravityDown), [gravityDown]);
  const mainHeaderImageStyleMemo = (0, _react.useMemo)(() => mainHeaderImageStyle(imageStyle, imageScale), [imageStyle, imageScale]);
  return /*#__PURE__*/_react.default.createElement(_reactNative.SafeAreaView, {
    style: styles.safeAreaView
  }, !!image && /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
    style: styles.imageContainerView
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Animated.Image, {
    source: image,
    style: mainHeaderImageStyleMemo
  }), /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
    style: gravityDownHeaderStyleMemo
  }, renderImageItem())), /*#__PURE__*/_react.default.createElement(_reactNative.Animated.ScrollView, _extends({
    bounces: false,
    ref: ref,
    snapToInterval: width,
    onScroll: _onScrollHandler,
    stickyHeaderIndices: allowStickyHeader
  }, props), !!image && /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.scrollViewTopBox
  }), renderHeader() && /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
    ref: headerRef,
    style: animatedHeaderStyleMemo
  }, renderHeader()), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: containerStyle
  }, children)));
});

var _default = HeaderImageScroll;
exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  imageContainerView: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'center',
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0
  },
  animatedViewRadius: {
    minHeight: 50,
    width,
    backgroundColor: '#fff',
    justifyContent: "center",
    alignItems: "center",
    overflow: 'hidden'
  },

  /**
   * FIXME 70 is Hardcore height for ScrollView Header 
   * looking for some help so this can be make dynamic for all iOS devices
   **/
  scrollViewTopBox: {
    height: width - (_reactNative.StatusBar.currentHeight || 70),
    width,
    backgroundColor: 'transparent'
  },
  renderHeaderContainer: {
    width,
    position: 'absolute',
    bottom: 0,
    left: 0,
    right: 0
  },
  safeAreaView: {
    flex: 1
  }
});

function mainHeaderImageStyle(imageStyle, imageScale) {
  return _reactNative.StyleSheet.flatten([imageStyle, {
    transform: [{
      scale: imageScale
    }]
  }]);
}

function gravityDownHeaderStyle(gravityDown) {
  return _reactNative.StyleSheet.flatten([styles.renderHeaderContainer, {
    transform: [{
      translateY: gravityDown
    }]
  }]);
}

function animatedHeaderStyle(borderRadiusValue, containerStyle) {
  return _reactNative.StyleSheet.flatten([styles.animatedViewRadius, {
    borderTopLeftRadius: borderRadiusValue,
    borderTopRightRadius: borderRadiusValue,
    backgroundColor: (containerStyle === null || containerStyle === void 0 ? void 0 : containerStyle.backgroundColor) || '#fff'
  }]);
}
//# sourceMappingURL=AnimatedScroll.js.map