function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/* eslint-disable prettier/prettier */
import React, { useMemo, useRef } from 'react';
import { Animated, Dimensions, StyleSheet, View, SafeAreaView, StatusBar } from 'react-native';
const {
  width
} = Dimensions.get('window');
const inputValue = [1, 1.5, 2];
const HeaderImageScroll = /*#__PURE__*/React.forwardRef((_ref, ref) => {
  let {
    children,
    image,
    containerStyle,
    imageStyle = {
      height: width,
      width,
      resizeMode: 'cover'
    },
    renderImageItem = () => /*#__PURE__*/React.createElement(React.Fragment, null),
    renderHeader = () => null,
    ...props
  } = _ref;
  const animatedValue = new Animated.Value(1);
  const headerRef = useRef();
  console.log(animatedValue);
  const imageScale = animatedValue.interpolate({
    inputRange: [-1, 1, 2],
    outputRange: [2, 1, 2],
    extrapolate: 'clamp'
  });
  const borderRadiusValue = animatedValue.interpolate({
    inputRange: inputValue,
    outputRange: [30, 15, 0],
    extrapolate: "clamp"
  });
  const gravityDown = animatedValue.interpolate({
    inputRange: [1, 1.1],
    outputRange: [5, 100],
    extrapolate: "clamp"
  });

  const _onScrollHandler = e => {
    const scrollYPositionByWidth = e.nativeEvent.contentOffset.y / width + 1;

    if (scrollYPositionByWidth < 3) {
      animatedValue.setValue(scrollYPositionByWidth);
    }
  };

  const animatedHeaderStyleMemo = useMemo(() => animatedHeaderStyle(borderRadiusValue, containerStyle), [borderRadiusValue, containerStyle]);
  const allowStickyHeader = useMemo(() => renderHeader() ? [1] : undefined, [renderHeader]);
  const gravityDownHeaderStyleMemo = useMemo(() => gravityDownHeaderStyle(gravityDown), [gravityDown]);
  const mainHeaderImageStyleMemo = useMemo(() => mainHeaderImageStyle(imageStyle, imageScale), [imageStyle, imageScale]);
  return /*#__PURE__*/React.createElement(SafeAreaView, {
    style: styles.safeAreaView
  }, !!image && /*#__PURE__*/React.createElement(Animated.View, {
    style: styles.imageContainerView
  }, /*#__PURE__*/React.createElement(Animated.Image, {
    source: image,
    style: mainHeaderImageStyleMemo
  }), /*#__PURE__*/React.createElement(Animated.View, {
    style: gravityDownHeaderStyleMemo
  }, renderImageItem())), /*#__PURE__*/React.createElement(Animated.ScrollView, _extends({
    bounces: false,
    ref: ref,
    snapToInterval: width,
    onScroll: _onScrollHandler,
    stickyHeaderIndices: allowStickyHeader
  }, props), !!image && /*#__PURE__*/React.createElement(View, {
    style: styles.scrollViewTopBox
  }), renderHeader() && /*#__PURE__*/React.createElement(Animated.View, {
    ref: headerRef,
    style: animatedHeaderStyleMemo
  }, renderHeader()), /*#__PURE__*/React.createElement(View, {
    style: containerStyle
  }, children)));
});
export default HeaderImageScroll;
const styles = StyleSheet.create({
  imageContainerView: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'center',
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0
  },
  animatedViewRadius: {
    minHeight: 50,
    width,
    backgroundColor: '#fff',
    justifyContent: "center",
    alignItems: "center",
    overflow: 'hidden'
  },

  /**
   * FIXME 70 is Hardcore height for ScrollView Header 
   * looking for some help so this can be make dynamic for all iOS devices
   **/
  scrollViewTopBox: {
    height: width - (StatusBar.currentHeight || 70),
    width,
    backgroundColor: 'transparent'
  },
  renderHeaderContainer: {
    width,
    position: 'absolute',
    bottom: 0,
    left: 0,
    right: 0
  },
  safeAreaView: {
    flex: 1
  }
});

function mainHeaderImageStyle(imageStyle, imageScale) {
  return StyleSheet.flatten([imageStyle, {
    transform: [{
      scale: imageScale
    }]
  }]);
}

function gravityDownHeaderStyle(gravityDown) {
  return StyleSheet.flatten([styles.renderHeaderContainer, {
    transform: [{
      translateY: gravityDown
    }]
  }]);
}

function animatedHeaderStyle(borderRadiusValue, containerStyle) {
  return StyleSheet.flatten([styles.animatedViewRadius, {
    borderTopLeftRadius: borderRadiusValue,
    borderTopRightRadius: borderRadiusValue,
    backgroundColor: (containerStyle === null || containerStyle === void 0 ? void 0 : containerStyle.backgroundColor) || '#fff'
  }]);
}
//# sourceMappingURL=AnimatedScroll.js.map