import React from 'react';
import { ImageSourcePropType, ImageStyle, ViewStyle, ScrollViewProps, ScrollView } from 'react-native';
declare type Props = {
    image: ImageSourcePropType;
    /**
     * @type imageStyle
     * @description styling object for header image
     **/
    imageStyle?: ImageStyle;
    /**
     * @type containerStyle
     * @description styling object for renderHeader container
     **/
    containerStyle?: ViewStyle;
    children: JSX.Element | JSX.Element[];
    /**
     * @type renderImageItem
     * @description render animated image description which will have default slide down/up animation
     **/
    renderImageItem?: () => JSX.Element | JSX.Element[];
    /**
     * @type renderHeader
     * @description render header item for scrollview
     **/
    renderHeader?: () => JSX.Element | JSX.Element[] | null;
};
declare const HeaderImageScroll: React.ForwardRefExoticComponent<Props & ScrollViewProps & React.RefAttributes<ScrollView>>;
export default HeaderImageScroll;
